      program extractnk
       use netk
       integer i,j,k,kk
!
!   initialization
       call readspectra      
      write (6,*) 'uno'
     
!   background spectra
       call spectrabckg(Tbckg)
      write (6,*) 'dos'
          
!   1st guess of n and k
       call initntot
       write (6,*) 'after initnot'

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      write(*,*) 'cycle 1'
!       1st cycle

      do k=1,3
       
      ! offset correction, corrected experimental spectra stored in Xexp
      write (6,*) k
        call offsetcorrection(Xexp0,Xexp)        
         
      ! optimize thickness
        call optiD(dddbon)
         write (6,*) dddbon
      ! optimize coherence in a non absorbtion range of freq.
        call optiC(c,nlamdamin3,nlamdamax3)
         write (6,*) c
      enddo
      !K-K. iterative procedure (typically 3 iteration to converge)
      do k=1,3
       !   optimization of k
       call optiK(1,nlamda)
       do i=1,nlamda
       write(36,*) lamda(i), nktot(i)
       enddo
       !   Kramers-Kronig to recompute n
       call kramkron
      enddo       
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!       may be good to print intermediate result to check
        open(95,file='salida-intermed.dat',status='unknown')
        do j=1,nlamda   !for all wavenumbers value
          do l=1,nd 
          call spectratot(Ntot(j),Nsub(j),Tbckg(j),dddbon(l),lamda(j),c(l),Xtheo(j,l))
          enddo
         ! here, print only uip to number of spectra files considered
        write(95,100) lamda(j),Xtheo(j,1),Xtheo(j,2),Xtheo(j,3),Xtheo(j,4)
        write(91,100) lamda(j),Xexp(j,1),Xexp(j,2),Xexp(j,3),Xexp(j,4)
        enddo
        close(95)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      write(*,*) 'cycle 2'
!        2nd cycle
        do kk=1,3

        ! refining n0
          call steepestN(n000,nlamdamin2,nlamdamax2,nlamdamin3,nlamdamax3,n0new) 
          n000=n0new
       write(*,*) 'n0', n000
          call kramkron

        ! optimize thickness
          call optiD(dddbon)

       write(*,*) 'ddd', dddbon
        ! optimize coherence in a non absorbtion range of freq.
         call optiC(c,nlamdamin3,nlamdamax3)

           
      write(*,*) 'c', c 
         !K-K. iterative procedure (typically 3 iteration to converge)
          do k=1,3
            !   optimization of k
            call optiK(1,nlamda)
            !   Kramers-Kronig to recompute n
            call kramkron
          enddo       
        enddo
        do j=1,nlamda
           write(96,*) lamda(j),real(ntot(j)), aimag(ntot(j))
       enddo
      
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      write(*,*) 'cycle 3'
!        3rd cycle
      do kk=1,2
      write (6,*) kk
 
      ! optimize thickness
        call optiD(dddbon)
        call optiC(c,nlamdamin3,nlamdamax3)
         !K-K. iterative procedure (typically 3 iteration to converge)
          do k=1,2
          write (6,*) k
            !   optimization of k
            call optiK(1,nlamda)
            !   Kramers-Kronig to recompute n
            call kramkron
          enddo
      enddo     
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! printing result

       open(98,file='optmized',status='unknown')
          write(98,*) 'thickness', dddbon
          write(98,*) 'coherence', c
          write(98,*) 'n0', n000
       close(98)
       open(97,file='correctedXexp.dat',status='unknown')
        do i=1,nlamda
              write(97,100) lamda(i), (Xexp(i,j),j=1,nd)
        enddo
       close(97)

       open(99,file='salida-der.dat',status='unknown')
       open(96,file='nk.dat',status='unknown')
        do j=1,nlamda   !for all wavenumbers value
          do i=1,nd
          call spectratot(Ntot(j),Nsub(j),Tbckg(j),dddbon(i),lamda(j),c(i),Xtheo(j,i))
          enddo
! print in file fort.96 output the result for n and k 
           write(96,100 ) lamda(j),real(ntot(j)), aimag(ntot(j))
!    print in file salida.dat the simulated spectra with the n and k values found
           write(99,100) lamda(j),(Xtheo(j,i),i=1,nd) 
        enddo
       close(99)
       close(96)
! IMPORTANT    modificar como (nd+1)f12.5
100 format (5f12.5)
       end program

